<?php
header('Content-Type: text/html; charset=utf-8');
	function test_Math($count = 50000) {
		$time_start = microtime(true);
		$mathFunctions = array("abs", "acos", "asin", "atan", "bindec", "floor", "exp", "sin", "tan", "pi", "is_finite", "is_nan", "sqrt");
		foreach ($mathFunctions as $key => $function) {
			if (!function_exists($function)) unset($mathFunctions[$key]);
		}
		for ($i=0; $i < $count; $i++) {
			foreach ($mathFunctions as $function) {
				$r = call_user_func_array($function, array($i));
			}
		}
		return number_format(microtime(true) - $time_start, 3);
	}
	
	
	function test_StringManipulation($count = 100000) {
		$time_start = microtime(true);
		$stringFunctions = array("addslashes", "chunk_split", "metaphone", "strip_tags", "md5", "sha1", "strtoupper", "strtolower", "strrev", "strlen", "soundex", "ord");
		foreach ($stringFunctions as $key => $function) {
			if (!function_exists($function)) unset($stringFunctions[$key]);
		}
		$string = "the quick brown fox jumps over the lazy dog";
		for ($i=0; $i < $count; $i++) {
			foreach ($stringFunctions as $function) {
				$r = call_user_func_array($function, array($string));
			}
		}
		return number_format(microtime(true) - $time_start, 3);
	}


	function test_Loops($count = 10000000) {
		$time_start = microtime(true);
		for($i = 0; $i < $count; ++$i);
		$i = 0; while($i < $count) ++$i;
		return number_format(microtime(true) - $time_start, 3);
	}

	
	function test_IfElse($count = 10000000) {
		$time_start = microtime(true);
		for ($i=0; $i < $count; $i++) {
			if ($i == -1) {
			} elseif ($i == -2) {
			} else if ($i == -3) {
			}
		}
		return number_format(microtime(true) - $time_start, 3);
	}	
function geoip($ip){//https://ipwhois.io/ru/documentation
    //$ip = gethostbyname($_SERVER['SERVER_NAME']);
    $ch = curl_init('http://ipwho.is/'.$ip.'?lang=ru');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HEADER, false);
    $ipwhois = json_decode(curl_exec($ch), true);
    curl_close($ch);
    if($ipwhois['success'] == false){
      return $ipwhois['message'];
    }else{
    if($ipwhois['security']['hosting']){$host = " Hosting";}else{$host = "";}
    return '<span id="geoinfo">'.$ipwhois['country'] . ' <img src="'.$ipwhois['flag']['img'].'" style="border: 1px solid #B9B9B9; height: 18px; vertical-align: bottom;" /> ' .$ipwhois['city'] . ' ' . $ipwhois['flag']['emoji'].$host.'</span>'; // Выведет: United States 
    }
}
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0" />
<link rel="shortcut icon" href="/images/favicon.ico" type="image/x-icon" />
<script src="https://code.jquery.com/jquery-1.9.1.js"></script>
<script type="text/javascript">
 $(document).ready(function(){
    var iph = '<?php	echo gethostbyname($_SERVER['SERVER_NAME']); ?>'; // Оставьте пустым для поиска текущего IP-адреса
    var ipc = '<?php	echo $_SERVER['REMOTE_ADDR']; ?>';
    
    if($('#geohost').text()=='You\'ve hit the monthly limit'){
        geoIp(iph, ipc, 'host');
    }
    datacl();
});
function geoIp(iph, ipc, fip){
    if(fip == "host"){ip = iph;}else{ip = ipc;}
    $.ajax({
	   method: 'GET',
	   contentType: 'application/json',
	   url: 'https://ipwho.is/' + ip+'?lang=ru',
	   dataType: 'json',
	   success: function(ipwhois) {
	       var geostr = ipwhois.country + ' ' + ipwhois.flag.emoji +' <img src="'+ ipwhois.flag.img +'" style="border: 1px solid #B9B9B9; height: 18px; vertical-align: bottom;" /> '+ipwhois.city;
        if(fip == "host"){$('#geohost').html(geostr);
        setTimeout(geoIp(iph, ipc, 'client'), 3000);
        }
        if(fip == 'client'){$('#geoclient').html(geostr);}
      }
    });
}
function datacl(){
    let date = new Date();
    var datecl = date.toLocaleTimeString();
    $('#datecl').text(datecl);
}
</script>
<style type="text/css">
body{
    overflow-x: hidden;
    background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAFfKj/FAAAAGXRFWHRTb2Z0d2FyZQBBZG9iZSBJbWFnZVJlYWR5ccllPAAAAAlQTFRF4OXp8PX50NXZBLxR6QAAAEhJREFUeNpiYGJgYGACCCAGMAAIIDiDCSCAGLAAgABCEcbBBAggGIORQhogwNCcwIjddKgQI6ojUbkgWSYMo+BCjKiOR9PLBAAchAAxHFDBbwAAAABJRU5ErkJggg==');
}
#conteiner{
    max-width: 100vw; height: calc(100vh - 50px);
    padding-top: 10px;
    border: 0px solid red;
    font-family: Times New Roman, Arial, Trebuchet MS;
    text-align: center;
}
.banchblok{width: 460px; border: 1px solid black; border-radius: 10px; background-color: white; text-align: left; padding: 0 10px 10px 30px; font-size: 14px;}
.contbloc{
    position: relative;
    display: inline-block; border: 1px dashed black; border-radius: 10px;
    padding: 10px; text-align: center;
    width: 480px;
    background-color: #D6D6D6;
}
.chapkatext{display: inline-block; position: absolute; top: -8px; left: 137px;
  font-size: 1.4rem;
  color: #FDFFAB;
  text-shadow: 1px 1px #372911, 1px 2px #372911, 1px -1px #372911, -1px 1px #372911, -1px -1px #372911, 3px 3px 6px rgba(0,0,0,.5);
  font-family: Times, Times New Roman, Georgia, serif;
  letter-spacing: 0.15em;
  -ms-user-select: none;
  -moz-user-select: none;
  -khtml-user-select: none;
  -webkit-user-select: none;
  font-weight: bolder;
  overflow:auto;
}
.chapkatext:hover{color: red;}
/* BIGIN CSS title */
.jn-tooltip {
	display: inline;
	position: relative;
}
.jn-tooltip:hover:after {
	content: attr(data-title);
	z-index: 999;
	position: absolute;
	top: 23px;
	left: 26.5%;
	width: 195px;
	padding: 7px 15px 10px 15px;
	font-size: 13px;
	font-weight: 300;
	color: #fff;
	background-color: #444;
	-moz-border-radius: 3px;
	-webkit-border-radius: 3px;
	-o-border-radius: 3px;
	-ms-border-radius: 3px;
	border-radius: 3px;
}
.jn-tooltip:hover:before {
	content: "";
	z-index: 1000;
	position: absolute;
	top: 18px;
	left: 50%;
	border-style: solid;
	border-width: 0px 6px 5px 6px;
	border-color: #444 transparent;
}
/* END title */
.mknrazdel{
    display: inline-block;
    margin: 8px;
    padding: 5px;
    display: inline-block;
    width: calc(100% - 25px);
    height: 60px;
    border: 2px solid black;
    border-radius: 10px;
    font-size: 1.9em;
    vertical-align:middle;
    text-align: center;
    line-height: 60px;
  box-shadow:
  0 0 40px rgba(0, 0, 0, .2) inset,
  -1px 0px rgb(170,170,170), -1px 1px rgb(180,180,180),
  -2px 1px rgb(169,169,169), -2px 2px rgb(179,179,179),
  -3px 2px rgb(168,168,168), -3px 3px rgb(178,178,178),
  -4px 3px rgb(167,167,167), -4px 4px rgb(177,177,177),
  -5px 4px rgb(166,166,166), -5px 5px rgb(176,176,176);
  vertical-align: middle;
  background: linear-gradient(-45deg, #FEE864, #F5965E);
  color: white;
  text-shadow: 1px 1px #372911, 1px 2px #372911, 1px -1px #372911, -1px 1px #372911, -1px -1px #372911, 3px 3px 6px rgba(0,0,0,.5);
  font-family: Times, Times New Roman, Georgia, serif;
  letter-spacing: 0.05em;
  -ms-user-select: none;
  -moz-user-select: none;
  -khtml-user-select: none;
  -webkit-user-select: none;
  font-weight: bolder;
  overflow:auto;
  text-overflow: ellipsis;
  cursor: pointer;
}
.mknrazdel:hover{
    background: linear-gradient(45deg, #FEE864, #F5965E);
}
.mknrazdel:active{
    margin: 11px 5px 5px 5px;
    box-shadow:
   -1px 0px rgb(170,170,170), -1px 1px rgb(180,180,180),
   -2px 1px rgb(169,169,169), -2px 2px rgb(179,179,179);
}

</style>
</head>
<body>
<div id="conteiner">
<div class="contbloc" style="display: block; margin: auto; ">
<a class="jn-tooltip" href="https://my-skills.ru/public/skript_testirovaniya_hostinga_testHost.html" target="_blank" data-title="Кликните для перехода на страницу&#013;с описанием работы скрипта"><img src="https://my-skills.ru/images/my-skills-top-512.png" alt="Мои навыки. Тесты хостинга." width="470" /><br />
<div class="chapkatext">МОИ НАВЫКИ</div></a>
</div>
<div class="contbloc" style="display: block; margin: auto; margin-top: 8px; padding-bottom: 6px;">
<a href="https://shneider-host.ru/u2576"><img src="https://shneider-host.ru/promo/4.jpg" title="Хостинг сайтов Шнайдер-хост"></a>
</div>
<div class="banchblok" style="display: block; margin: auto; margin-top: 8px;">
<?php
	$numtimes=$_GET["numtimes"];
	if ($numtimes <=0) {
		$numtimes = 1;
	}
	if ($numtimes>10) {
		$numtimes =10;
	}
	$functions = get_defined_functions();
	$line = str_pad("-",56,"-");
	echo "<pre>\n$line\n|".str_pad("PHP BENCHMARK SCRIPT",54," ",STR_PAD_BOTH)."|\n$line\nStart : ".date("Y-m-d H:i:s")."\nServer : {$_SERVER['SERVER_NAME']}@{$_SERVER['SERVER_ADDR']}\nPHP version : ".PHP_VERSION."\nPlatform : ".PHP_OS. "\n$line\n";
	for ($xrun=1;$xrun<=$numtimes;$xrun++) {
		$total = 0;
		foreach ($functions['user'] as $user) {
			if (preg_match('/^test_/', $user)) {
				$total += $result = $user();
				echo "Test #".$xrun." ".str_pad($user, 33) . " : " . sprintf("%5.2f",$result) ." seconds\n";
			}
		}
		$totaltime = sprintf("%5.2f",$totaltime + $total);
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
			$serverphpload = 0;
		}  else {
			$serverphpload = sys_getloadavg();
			$serverload = sprintf("%5.2f",$serverphpload[0]);
			$tserverload=sprintf("%5.2f",$tserverload+$serverload);
			$results[]=sprintf("%5.2f",$total);	
			printf("<br>Server time                               :<b> %5.02f</b> seconds",$total);
			printf("<br>Server load (now)                         :<b> %5.02f</b>",$serverload);
		}
		echo "<br>".$line."\n";
		echo str_repeat(' ',1024*64); // for flush to work in IE...
		echo "\n";
		ob_flush(); 
		flush();
	}
	$besttime = min($results);
	$worsttime= max($results);
	if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
		$serverphpload = 0;
	} else {
		$serverphpload = sys_getloadavg();
	} 
	printf("Total time                                :<b> %5.02f</b> seconds",$totaltime);
	if ($numtimes>1) {
		$avgload = sprintf("%5.2f",$tserverload/$numtimes);
		printf("<br>Average per test                          :<b> %5.02f</b> seconds",$totaltime/$numtimes);
		printf("<br>Best time                                 :<b> %5.02f</b> seconds",$besttime);
		printf("<br>Worst time                                :<b> %5.02f</b> seconds<br>",$worsttime);
		printf("<br>Total server load                         :<b> %5.02f</b>",$tserverload);
		printf("<br>Average server load                       :<b> %5.02f</b>",$avgload);
	}
	printf("<br>Average load last 5 minutes               :<b> %5.02f</b>",$serverphpload[1]);
	printf("<br>Average load last 15 minutes              :<b> %5.02f</b>",$serverphpload[2]);
	$memorylimit = ini_get("memory_limit"); 
	printf("<br>PHP memory limit                          :<b> %5.00f</b> Mbyte<br>",$memorylimit);
	echo "</pre>";
	
	echo "<font face='Verdana,arial' size='2'>Вы можете скачать ZIP-архив с файлом &laquo;testHost.php&raquo; по ссылке: ".'<a download="download" href="https://my-skills.ru/php/download.php?file=testHost.zip"><font face="Verdana,arial" size="2">Download file</font></a>.';
	echo "<br>Затем распаковать в корневой каталог сайта и протестировать свой хостинг (требуется от PHP 5 до PHP 7.4).\n";	
	echo "<br><br><font face='Verdana,arial' size='2'>Client: ".$_SERVER['REMOTE_ADDR'].' <span id="geoclient">'.geoip($_SERVER['REMOTE_ADDR']).'</span> <span id="datecl"></span>';
    echo "<br /><font face='Verdana,arial' size='2'>Host: ".gethostbyname($_SERVER['SERVER_NAME'])." <span id=\"geohost\">".geoip(gethostbyname($_SERVER['SERVER_NAME']))."</span>".'</span> <span id="datehost">'.date('G:i:s').'</span>';
?>

</div>
<div class="contbloc" style="display: block; margin: auto; margin-top: 8px;">
<div class="mknrazdel" onclick="location = location">ПОВТОРИТЬ ТЕСТ</div>
</div>
</div>
</body>
</html>